// import classes
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.awt.font.*;
import java.awt.print.*;
import java.awt.datatransfer.*;
import java.io.*;
import java.util.*;
import java.lang.*;

/***************************************************************************/
/* CLASS: PaintMagic                                                       */
/***************************************************************************/
public class PaintMagic extends Frame
{							/*end at 638*/
  Frame parent = this;
  MyMenuHandler handler = new MyMenuHandler();
  MyCanvas canvas;
  Panel toolbar = new Panel();
  Panel standardBar = new Panel();
  Panel statusBar = new Panel();
  static TextField status1 = new TextField(35);
  static Label status2 = new Label("                                 ");
  static TextField status3 = new TextField(9);
  static MenuItem edit_cut, edit_copy, edit_paste;
  
  ScrollPane sp = new ScrollPane();
  static MyButton cutB, copyB, pasteB;/*645*/
  Button b[];

  // ---- The starting point - the main function.
  public static void main(String args[])
  {
  	long startTime = System.currentTimeMillis();
  	System.out.println("\n\t\t\t\tPAINT-MAGIK 2.0");
    System.out.println("\nStarting Application. . .\n");
    new PaintMagic();
    long endTime = System.currentTimeMillis();
    System.out.println("\nApplication Load Time = " + (endTime - startTime) + " milliseconds.");
    System.out.println("\nApplication loaded and running...HAVE FUN!\n");
  }

  // ---- Constructor function
  public PaintMagic()
  {
//    super("Paint-MagiK 2.0");

    Toolkit tk = Toolkit.getDefaultToolkit();/*toolkit is a class*/
    Dimension d = tk.getScreenSize();
    int screenHeight = d.height;
    int screenWidth = d.width;

    Image img = tk.getImage("gifs\\duke.gif");/*encapsulates the img found st url as given*/
    setIconImage(img);

    setBackground(Color.gray);
    setLayout(new BorderLayout());

    System.out.print("Loading menus...");
    setupMenu();/*105*/
    System.out.println("done.");
    
    System.out.print("Loading standard & status bars...");
    setupStandardBar();/*343*/
    setupStatusBar();/*372*/
    System.out.println("done.");    

    System.out.print("Loading tools...");
    setupTool();/*234*/
    System.out.println("done.");
    
    
    System.out.print("Loading canvas...");
    canvas = new MyCanvas(MyCanvas.PEN);/*MyCanvas is a class at735 to 2300*/
    sp.add(canvas);
    add("Center",sp);
    System.out.println("done.");    

    setSize(screenWidth,screenHeight-50);
    canvas.setParent(parent);
    
    addWindowListener(new WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
      	System.out.println("\n*************************************************************");
      	System.out.println("Application exited! Thank You for using Paint-Magic 1.0.");
      	System.out.println("\nProgrammers:");
      	System.out.println("\tA.Subramanyam\t\t Sreedhara R.A");
      	System.out.println("\t1da99is039\t\t 1da99IS036");
      	System.out.println("\tsubbu@indya.com\t\t sree@indiatimes.com");
      	System.out.println("*************************************************************");
      	System.out.println("");
      	System.exit(0);
      }
    });
  }
  

  /******************************/
  /* setup the menus            */
  /******************************/
  void setupMenu()
  {
    MenuBar mbar = new MenuBar();
    setMenuBar(mbar);

    Menu file = new Menu("File");
    Menu edit = new Menu("Edit");
    Menu view = new Menu("View");
    Menu image = new Menu("Image");
    Menu filter = new Menu("Filter");
    Menu help = new Menu("Help");

    MenuItem item1,item2,item3,item4,item5,item6;
    file.add(item1 = new MenuItem("New",new MenuShortcut(KeyEvent.VK_N)));
    file.add(item2 = new MenuItem("Open",new MenuShortcut(KeyEvent.VK_O)));
    file.add(item3 = new MenuItem("Save",new MenuShortcut(KeyEvent.VK_S)));
    file.add(item4 = new MenuItem("Save as..."));
    file.add(new MenuItem("-"));
    file.add(item5 = new MenuItem("Print",new MenuShortcut(KeyEvent.VK_P)));
    file.add(new MenuItem("-"));
    file.add(item6 = new MenuItem("Exit",new MenuShortcut(KeyEvent.VK_F4,true)));
    mbar.add(file);

    item1.addActionListener(handler);/*actionPerformed is at 411*/
    item2.addActionListener(handler);
    item3.addActionListener(handler);
    item4.addActionListener(handler);
    item5.addActionListener(handler);
    item6.addActionListener(handler);

    // --- the Edit menu
    MenuItem item11,item12,item13,item14;
    edit.add(item11 = new MenuItem("Undo",new MenuShortcut(KeyEvent.VK_Z)));
    edit.add(item12 = new MenuItem("Redo",new MenuShortcut(KeyEvent.VK_F4)));
    edit.add(new MenuItem("-"));
    edit.add(edit_cut = new MenuItem("Cut",new MenuShortcut(KeyEvent.VK_X)));
    edit_cut.setEnabled(false);
    edit.add(edit_copy = new MenuItem("Copy",new MenuShortcut(KeyEvent.VK_C)));
    edit_copy.setEnabled(false);
    edit.add(edit_paste = new MenuItem("Paste",new MenuShortcut(KeyEvent.VK_V)));
    edit_paste.setEnabled(false);
    edit.add(new MenuItem("-"));
    edit.add(item13 = new MenuItem("Clear Selection",new MenuShortcut(KeyEvent.VK_DELETE)));
    edit.add(item14 = new MenuItem("Select All",new MenuShortcut(KeyEvent.VK_A)));
    mbar.add(edit);

    item11.addActionListener(handler);
    item12.addActionListener(handler);
    item13.addActionListener(handler);
    item14.addActionListener(handler);
    edit_cut.addActionListener(handler);
    edit_copy.addActionListener(handler);
    edit_paste.addActionListener(handler);

    // ---- the View menu
    CheckboxMenuItem v_item1,v_item2,v_item3;
    view.add(v_item1 = new CheckboxMenuItem("Standard Bar",true));
    view.add(v_item2 = new CheckboxMenuItem("Status Bar",true));
    view.add(v_item3 = new CheckboxMenuItem("Tool Bar",true));
    
    v_item1.addItemListener(handler);
    v_item2.addItemListener(handler);
    v_item3.addItemListener(handler);
    
    mbar.add(view);
    
    // ---- the Image menu
    MenuItem item31,item32,item33,item34,item35,item36;
    image.add(item31 = new MenuItem("ReLoad", new MenuShortcut(KeyEvent.VK_R)));
    image.add(item32 = new MenuItem("Rotate"));
    image.add(item33 = new MenuItem("Scale",new MenuShortcut(KeyEvent.VK_W)));
    image.add(item34 = new MenuItem("Canvas Size",new MenuShortcut(KeyEvent.VK_E)));
    image.add(item35 = new MenuItem("Clear Image",new MenuShortcut(KeyEvent.VK_N)));
    image.add(item36 = new MenuItem("Crop"));
    mbar.add(image);

    item31.addActionListener(handler);
    item32.addActionListener(handler);
    item33.addActionListener(handler);
    item34.addActionListener(handler);
    item35.addActionListener(handler);
    item36.addActionListener(handler);

    // ---- the Filter menu
    MenuItem filter_grayscale,filter_invert,filter_contrast;
    MenuItem filter_brightness,filter_dissolve,filter_color,filter_shadow;
    MenuItem filter_bleach,filter_wave;
    MenuItem filter_blur,filter_sharpen,filter_posterize;
    filter.add(filter_brightness = new MenuItem("Brightness"));
    filter.add(filter_grayscale = new MenuItem("GrayScale"));
    filter.add(filter_invert = new MenuItem("Invert Colors"));
    filter.add(filter_contrast = new MenuItem("Contrast"));
    filter.add(filter_dissolve = new MenuItem("Dissolve"));
    filter.add(filter_color = new MenuItem("Color Mask"));
    filter.add(filter_shadow = new MenuItem("Shadow"));    
    filter.add(filter_blur = new MenuItem("Blur"));
    filter.add(filter_sharpen = new MenuItem("Sharpen"));
    filter.add(filter_posterize = new MenuItem("Posterize"));
    filter.add(filter_bleach = new MenuItem("Bleach"));
    filter.add(filter_wave = new MenuItem("Wave"));
    mbar.add(filter);

    filter_brightness.addActionListener(handler);
    filter_grayscale.addActionListener(handler);
    filter_invert.addActionListener(handler);
    filter_contrast.addActionListener(handler);
    filter_dissolve.addActionListener(handler);
    filter_color.addActionListener(handler);
    filter_shadow.addActionListener(handler);
    filter_blur.addActionListener(handler);
    filter_sharpen.addActionListener(handler);
    filter_posterize.addActionListener(handler);
    filter_bleach.addActionListener(handler);
    filter_wave.addActionListener(handler);

    // ---- the Help menu
    MenuItem item51,item52;
    help.add(item51 = new MenuItem("Help"));
    help.add(item52 = new MenuItem("About..."));
    mbar.add(help);

    item51.addActionListener(handler);
    item52.addActionListener(handler);

  }

  /******************************/
  /* setup the tool bar         */
  /******************************/
  void setupTool()
  { 
    Panel p1 = new Panel();
    MyButton pointerB = new MyButton("gifs\\pointer.gif","NONE","Pointer tool");
    MyButton penB = new MyButton("gifs\\pencil.gif","PEN","Freehand drawing (pencil)");
    p1.add(pointerB);
    p1.add(penB);
    
    Panel p2 = new Panel();   
    MyButton brushB = new MyButton("gifs\\brush.gif","BRUSH","Air Brush");
    MyButton textB = new MyButton("gifs\\text.gif","TEXT","Insert a text");
    p2.add(brushB);
    p2.add(textB);
    

    Panel p3 = new Panel();
    MyButton lineB = new MyButton("gifs\\line.gif","LINE","Draw a line");
    MyButton curveB = new MyButton("gifs\\curve.gif","CURVE","Draw a curve");
    p3.add(lineB);
    p3.add(curveB);
    
    Panel p4 = new Panel();
    MyButton rectB = new MyButton("gifs\\rectangl.gif","RECT","Draw a rectangle");
    MyButton fillrectB = new MyButton("gifs\\fillrect.gif","FILL_RECT","Draw a filled rectangle");
    p4.add(rectB);
    p4.add(fillrectB);
    
    Panel p5 = new Panel();
    MyButton rndrectB = new MyButton("gifs\\roundrec.gif","RNDRECT","Draw a rounded rectangle");
    MyButton fillrndrectB = new MyButton("gifs\\fillrndrec.gif","FILL_RNDRECT","Draw a filled rounded rectangle");
    p5.add(rndrectB);
    p5.add(fillrndrectB);

    Panel p6 = new Panel();
    MyButton ovalB = new MyButton("gifs\\ellipse.gif","OVAL","Draw an ellipse");
    MyButton fillovalB = new MyButton("gifs\\fillellipse.gif","FILL_OVAL","Draw a filled ellipse");
    p6.add(ovalB);
    p6.add(fillovalB);

    Panel p7 = new Panel();
    MyButton polygonB = new MyButton("gifs\\polygon.gif","POLY","Draw a polygon");
    MyButton selectB = new MyButton("gifs\\select.gif","SELECT","Select a rectangular region");
    p7.add(polygonB);
    p7.add(selectB);

    Panel p8 = new Panel();
    MyButton clearB = new MyButton("gifs\\clear.gif","CLEAR","Clear the graphics");
    MyButton colorB = new MyButton("gifs\\color.gif","COLOR","Choose a color");
    p8.add(clearB);
    p8.add(colorB);

    Panel p9 = new Panel();
    MyButton pZoomB = new MyButton("gifs\\zoomin.gif","+","Zoom In");
    MyButton nZoomB = new MyButton("gifs\\zoomout.gif","-","Zoom Out");
    p9.add(pZoomB);
    p9.add(nZoomB);

    pointerB.addActionListener(handler);
    penB.addActionListener(handler);
    brushB.addActionListener(handler);
    lineB.addActionListener(handler);
    rectB.addActionListener(handler);
    fillrectB.addActionListener(handler);
    rndrectB.addActionListener(handler);
    fillrndrectB.addActionListener(handler);
    ovalB.addActionListener(handler);
    fillovalB.addActionListener(handler);
    curveB.addActionListener(handler);
    polygonB.addActionListener(handler);
    selectB.addActionListener(handler);
    textB.addActionListener(handler);
    clearB.addActionListener(handler);
    colorB.addActionListener(handler);
    pZoomB.addActionListener(handler);
    nZoomB.addActionListener(handler);

    GridBagConstraints c = new GridBagConstraints();
    Panel mainPanel = new Panel(new GridBagLayout()); //(10,1));
    c.gridwidth = GridBagConstraints.REMAINDER;
    c.gridheight = 1;
    c.weightx=0.0;
    c.weighty=0.0;
    c.ipadx=0;
    c.ipady=0;
    c.insets = new Insets(0,0,0,0);
    
    mainPanel.add(p1,c);
    mainPanel.add(p2,c);
    mainPanel.add(p3,c);
    mainPanel.add(p4,c);
    mainPanel.add(p5,c);
    mainPanel.add(p6,c);
    mainPanel.add(p7,c);
    mainPanel.add(p8,c);
    mainPanel.add(p9,c);

    mainPanel.setBackground(Color.lightGray);
    toolbar.add(mainPanel);
    toolbar.setBackground(Color.gray);
//    toolbar.setCursor(new Cursor(Cursor.HAND_CURSOR));

    add("West",toolbar);
    setVisible(true);
  }
  

  /******************************/
  /* setup the standard bar     */
  /******************************/
  void setupStandardBar()
  {
  	MyButton newB = new MyButton("gifs\\new.gif","New","New Image");
  	MyButton openB = new MyButton("gifs\\open.gif","Open","Open a file");
  	MyButton saveB = new MyButton("gifs\\save.gif","Save","Save this file");
  	cutB = new MyButton("gifs\\cut.gif","Cut","Cut selection");
  	copyB = new MyButton("gifs\\copy.gif","Copy","Copy selection");
  	pasteB = new MyButton("gifs\\paste.gif","Paste","Insert contents of clipboard");
  	  	
  	standardBar.setLayout(new FlowLayout(FlowLayout.LEFT));
  	standardBar.add(newB);
  	standardBar.add(openB);
  	standardBar.add(saveB);
  	standardBar.add(cutB);
  	standardBar.add(copyB);
  	standardBar.add(pasteB);
  	
  	newB.addActionListener(handler);
  	openB.addActionListener(handler);
  	saveB.addActionListener(handler);
  	cutB.addActionListener(handler);
  	copyB.addActionListener(handler);
  	pasteB.addActionListener(handler);
  	
  	add("North",standardBar);
  	standardBar.setBackground(Color.lightGray);
  	setVisible(true);
  }
  
  void setupStatusBar()
  {  	
  	Label l2 = new Label("Current Tool:");
  	
  	l2.setFont(new Font("Times New Roman",Font.BOLD,11));
  	
  	statusBar.setLayout(new GridLayout(1,3));
  	
  	status1.setFont(new Font("Times New Roman",Font.BOLD,10));
  	status2.setFont(new Font("Times New Roman",Font.BOLD,10));
  	
  	status1.setBackground(Color.white);
  	status1.setEnabled(false);
  	Panel p1 = new Panel(new FlowLayout(FlowLayout.LEFT));
  	p1.add(status1);

   	Panel p2 = new Panel(new FlowLayout(FlowLayout.LEFT));
  	p2.add(l2);
  	p2.add(status2);
  	
  	
  	status3.setEnabled(false);
  	status3.setBackground(Color.blue);
  	status3.setFont(new Font("Times New Roman",Font.BOLD,12));
  	Panel p3 = new Panel(new FlowLayout(FlowLayout.RIGHT));
  	p3.add(status3);

  	statusBar.add(p1);
  	statusBar.add(p2);
  	statusBar.add(p3);
  	  	
  	statusBar.setBackground(Color.gray);
  	add("South",statusBar);
  	setVisible(true);
  }
  	  	
  // ---- MyMenuHandler class for handling events
  class MyMenuHandler implements ActionListener, ItemListener
  {
    public void actionPerformed(ActionEvent e)
    {
      String s=e.getActionCommand();
      getToolkit().beep();
      if(s.equals("Exit"))
      {
      	System.out.println("");
   	    System.out.println("*************************************************************");
      	System.out.println("* Application exited! Thank You for using Paint-Magic 1.0.  *");
      	System.out.println("*                                                           *");
      	System.out.println("* PROGRAMMERS:                                              *");
      	System.out.println("*        Sreedhara R.A                A.Subramanyam         *");
      	System.out.println("*        1DA99IS036                   IDA99IS039            *");
      	System.out.println("*        Sree@indya.com               Subbu@indiatimes.com  *");
      	System.out.println("*************************************************************");
      	System.out.println("");
      	System.exit(0);
      }
      else if(s.equals("New"))
      {
        canvas.clear();
        canvas.setNew(true);
        canvas.setSize(650,450);
        canvas.setFile(null);
        canvas.setTool(MyCanvas.PEN);
        validate();
      }
      else if(s.equals("Open"))
      {
        FileDialog fd = new FileDialog(parent,"File Open...");
        MyFilter f = new MyFilter();/*721*/
        fd.setDirectory("..\\images");
        fd.setFilenameFilter(f);        
        fd.setVisible(true);
        String fname = fd.getFile();
        if (fname==null)
        { canvas.setFile(canvas.getFile()); }
        else
        {
	        String fdir = fd.getDirectory();
	        fname = fdir + fname;
	        canvas.setFile(fname);
	        canvas.setTool(MyCanvas.IMAGE);
	      }
        validate();
      }
      else if(s.equals("Save"))
      {
      	String fname = canvas.getFile();

      	if(fname == null || !fname.endsWith(".pmg"))
      	{
	        FileDialog fd = new FileDialog(parent,"Save as...",FileDialog.SAVE);
	        fd.setDirectory("..\\images");
	        fd.setFile("untitled.pmg");
	        fd.setVisible(true);
	        fname = fd.getFile();
	        String fdir = fd.getDirectory();
	        fname = fdir + fname;
	        canvas.save(fname);
	      }        
      	if(fname.endsWith(".pmg"))
      	{
      		canvas.save(fname);
      	}
      }
      else if(s.equals("Save as..."))
      {
        FileDialog fd = new FileDialog(parent,"Save as...",FileDialog.SAVE);
        fd.setDirectory("..\\images");
        fd.setFile("untitled.pmg");
        fd.setVisible(true);
        String fname = fd.getFile();
        String fdir = fd.getDirectory();
        fname = fdir + fname;
        canvas.save(fname);
      }
      else if(s.equals("Cut"))
        canvas.setTool(MyCanvas.CUT);
      else if(s.equals("Copy"))
        canvas.setTool(MyCanvas.COPY);
      else if(s.equals("Paste"))
        canvas.setTool(MyCanvas.PASTE);        
      else if(s.equals("Print"))
      	canvas.printCanvas();
      else if(s.equals("Undo"))
        canvas.undo();
      else if(s.equals("Redo"))
        canvas.redo();
      else if(s.equals("Clear Selection"))
        canvas.clearSelect();
      else if(s.equals("Select All"))
        canvas.selectAll();
      else if(s.equals("ReLoad"))
      {
      	String fname = canvas.getFile();
        canvas.setFile(fname);
        canvas.setTool(MyCanvas.IMAGE);
      }
      else if(s.equals("Clear Image"))
      {
        canvas.clear();
        canvas.setSize(650,450);
        canvas.setTool(MyCanvas.PEN);
      }
      else if(s.equals("Rotate"))
        canvas.setTool(MyCanvas.ROTATE);
      else if(s.equals("Scale"))
      	canvas.setTool(MyCanvas.SCALE);
      else if(s.equals("Canvas Size"))
      {
        SizerDialog sd = new SizerDialog(parent,canvas.getSize());
        if(sd.status())
          canvas.setSize(sd.getNewSize());
          
      }
      else if(s.equals("Crop"))
        canvas.setTool(MyCanvas.CROP);
      else if(s.equals("Brightness"))
        canvas.setTool(MyCanvas.BRIGHT);
      else if(s.equals("GrayScale"))
        canvas.setTool(MyCanvas.GRAYSCALE);
      else if(s.equals("Invert Colors"))
        canvas.setTool(MyCanvas.INVERT);
      else if(s.equals("Contrast"))
        canvas.setTool(MyCanvas.CONTRAST);
      else if(s.equals("Dissolve"))
        canvas.setTool(MyCanvas.DISSOLVE);
      else if(s.equals("Color Mask"))
        canvas.setTool(MyCanvas.COLOR);
      else if(s.equals("Shadow"))
        canvas.setTool(MyCanvas.SHADOW);        
      else if(s.equals("Blur"))
        canvas.setTool(MyCanvas.BLUR);
      else if(s.equals("Sharpen"))
        canvas.setTool(MyCanvas.SHARPEN);
      else if(s.equals("Posterize"))
        canvas.setTool(MyCanvas.POSTERIZE);
      else if(s.equals("Bleach"))
        canvas.setTool(MyCanvas.BLEACH);
      else if(s.equals("Wave"))
        canvas.setTool(MyCanvas.WAVE);
      else if(s.equals("About..."))
      { AboutDialog a = new AboutDialog(parent); }

      // tool bar actions
      else if(s.equals("NONE"))
        canvas.setTool(MyCanvas.NONE);
      else if(s.equals("CLEAR"))
        canvas.clear();
      else if(s.equals("PEN"))
        canvas.setTool(MyCanvas.PEN);
      else if(s.equals("BRUSH"))
        canvas.setTool(MyCanvas.BRUSH);
      else if(s.equals("LINE"))
        canvas.setTool(MyCanvas.LINE);
      else if(s.equals("RECT"))
        canvas.setTool(MyCanvas.RECTANGLE);
      else if(s.equals("FILL_RECT"))
        canvas.setTool(MyCanvas.FILL_RECT);
      else if(s.equals("RNDRECT"))
        canvas.setTool(MyCanvas.RNDRECT);
      else if(s.equals("FILL_RNDRECT"))
        canvas.setTool(MyCanvas.FILL_RNDRECT);
      else if(s.equals("OVAL"))
        canvas.setTool(MyCanvas.OVAL);
      else if(s.equals("FILL_OVAL"))
        canvas.setTool(MyCanvas.FILL_OVAL);
      else if(s.equals("CURVE"))
        canvas.setTool(MyCanvas.CURVE);
      else if(s.equals("POLY"))
        canvas.setTool(MyCanvas.POLYGON);
      else if(s.equals("SELECT"))
        canvas.setTool(MyCanvas.SELECT);
      else if(s.equals("TEXT"))
      {
      	canvas.setParent(parent);
        canvas.setTool(MyCanvas.TEXT);
      }
      else if(s.equals("COLOR"))
      {
      	ColorDialog c = new ColorDialog(parent);
      	if(c.status())
      	 	canvas.setColor(c.getColor());
      }
      else if(s.equals("+"))
      {
      	canvas.setTool(MyCanvas.P_ZOOM);
      }
      else if(s.equals("-"))
      {
      	canvas.setTool(MyCanvas.N_ZOOM);
      }
    }    
    
	  public void itemStateChanged(ItemEvent e)
	  {
	  	Object i = e.getItem();
	  	
	  	if(i.equals("Tool Bar"))
	  	{
	  		if(e.getStateChange() == ItemEvent.DESELECTED)
	  	    remove(toolbar);
	  	  else
	  	    add("West",toolbar);
	  	}
	  	
	  	if(i.equals("Standard Bar"))
	  	{
	  		if(e.getStateChange() == ItemEvent.DESELECTED)
	  	    remove(standardBar);
	  	  else
	  	    add("North",standardBar);
	  	}

	  	if(i.equals("Status Bar"))
	  	{
	  		if(e.getStateChange() == ItemEvent.DESELECTED)
	  	    remove(statusBar);
	  	  else
	  	    add("South",statusBar);
	  	}
	  	
	  	paintAll(getGraphics());
	  }
  	
  }  
} /* ---- End Of class  -  PaintMagic   ----- */


/***************************************************************************/
/* CLASS:  MyButton                                                        */
/***************************************************************************/
class MyButton extends Button
{
	Image img;
	boolean flag;
	String tt;
	MyButton(String fname,String act,String tooltip)
	{
		super();		
		MediaTracker t = new MediaTracker(this);
		img = Toolkit.getDefaultToolkit().getImage(fname);
		t.addImage(img,0);
		try
		{
		  t.waitForID(0);
		}catch(Exception e) {}
		
		setActionCommand(act);
		setLabel("   ");
		setSize(img.getWidth(null),img.getHeight(null));
		setVisible(true);
		setCursor(new Cursor(Cursor.HAND_CURSOR));/*Hand symbol*/
		
		tt = tooltip;
		addMouseListener(new MouseAdapter()
		{
			public void mousePressed(MouseEvent e)
			{
				flag=true;
			}
			public void mouseReleased(MouseEvent e)
			{
				flag=false;
			}
		});
		
		addMouseMotionListener(new MouseMotionAdapter()
		{
			public void mouseMoved(MouseEvent e)
			{
				PaintMagic.status1.setText(tt);
			}
		});
			
	}
	
	public Insets getInsets()
  {
  	return new Insets(0,0,0,0);
  }


	public void paint(Graphics g)
	{
		super.paint(g);
	  g.drawImage(img,1,1,this);
	  if (flag)
	  {
//	  	g.setColor(Color.darkGray);
//	    g.draw3DRect(0,0,img.getWidth(null)-2,img.getHeight(null)-2,true);
	  }
	  else
	  {
	  	g.setColor(Color.lightGray);
	    g.draw3DRect(0,0,img.getWidth(null)-2,img.getHeight(null)-2,true);
	  }	    
	}
	
	public void update(Graphics g)
	{
		paint(g);
	}
}

/***************************************************************************/
/* CLASS:  MyFilter                                                        */
/***************************************************************************/
class MyFilter implements FilenameFilter
{
	public MyFilter()
	{
	}
		
	public boolean accept(File dir,String name)
	{
		if(name.endsWith("gif") || name.endsWith("jpg"))
		  return true;
		return false;
	}
}

/***************************************************************************/
/* CLASS:  MyCanvas                                                        */
/***************************************************************************/
class MyCanvas extends Canvas implements ActionListener, Printable, ClipboardOwner
{	/*upto 2032*/
  // the shapes
  public static final int NONE = 0;
  public static final int PEN = 1;
  public static final int CURVE = 2;
  public static final int BRUSH = 3;
  public static final int LINE = 4;
  public static final int RECTANGLE = 5;
  public static final int FILL_RECT = 6;
  public static final int RNDRECT = 7;
  public static final int FILL_RNDRECT = 8;
  public static final int OVAL = 9;
  public static final int FILL_OVAL = 10;
  public static final int POLYGON = 11;
  public static final int TEXT = 12;

  public static final int IMAGE = 20;
  public static final int UNDO = 21;
  public static final int CROP = 22;
  public static final int P_ZOOM = 23;
  public static final int N_ZOOM = 24;
  public static final int SCALE = 25;
  public static final int ROTATE = 26;
  public static final int SELECT = 27;
  public static final int CUT = 28;
  public static final int COPY = 29;
  public static final int PASTE = 30;
  
  // the filters
  public static final int DISSOLVE = 40;
  public static final int BLEACH = 41;
  public static final int BLUR = 42;
  public static final int BRIGHT = 43;
  public static final int COLOR = 44;
  public static final int CONTRAST = 45;
  public static final int GRAYSCALE = 46;
  public static final int INVERT = 47;
  public static final int POSTERIZE = 48;
  public static final int SHADOW = 49;
  public static final int SHARPEN = 50;
  public static final int WAVE = 51;
  
    
  private int tool = PEN;
  private int startX, startY, endX, endY;
  private int pX, pY;
  private int cx1, cx2, cy1, cy2;
  private int selX1, selX2, selY1, selY2;
  private int top, left, width, height;
  private int pasteX, pasteY;
  private int cWidth, cHeight;
  private int zWidth, zHeight;
  private int scaleWidth, scaleHeight;
  private int curveCnt;

  private Properties printprefs = new Properties(); // store user preferences
  private PopupMenu popup;
  
  private boolean newObject  = false;
  private boolean undoFlag   = false;
  private boolean zoomFlag   = false;
  private boolean curveFlag  = false;
  private boolean newFlag    = false;
  private boolean selectFlag = false;
  private boolean textFlag   = false;
  private boolean copyFlag   = false;
  private boolean brushFlag  = false;

  private MediaTracker tracker;
  private Image fimg=null;
  private Image img=null;
  private Image buffer=null;
  private Image tmpBuf=null;
  private Image undo=null;
  private Color color;
  
  private ConvolveOp cOp;
  private LookupOp lOp;
  private BufferedImageOp biOp;
  private AffineTransform at;
  private AffineTransformOp atOp;
  private BufferedImage source,destination;
  private Graphics gf;

  private Graphics b,t;
  private String fname;
  private String txt;
  private String curr_status;

  private FilterDialog fd;
  private ColorDialog cd;
  private Clipboard clipboard = new Clipboard("PaintMagiK Clipboard");
    
  private MenuItem pmCut=new MenuItem("Cut");
  private MenuItem pmCopy=new MenuItem("Copy");
  private MenuItem pmPaste=new MenuItem("Paste");
  private MenuItem pmClear=new MenuItem("Clear");
  private MenuItem pmCrop=new MenuItem("Crop");

  Frame parent;

  MyCanvas()
  { super();  }

  public MyCanvas(int toolType)/*constructor*/
  {
    super();
    tool = toolType;
    setBackground(Color.white);
    setColor(Color.black);
    setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
    
    clear();
    initVariables();
    setSize(650,450);
    setTool(PEN);

    // create the popup menu
    popup = new PopupMenu();
    
    popup.add(pmCut);
    pmCut.addActionListener(this);
    popup.add(pmCopy);
    pmCopy.addActionListener(this);
    popup.add(pmPaste);
    pmPaste.addActionListener(this);
    popup.add(new MenuItem("-"));
    popup.add(pmClear);
    pmClear.addActionListener(this);
    popup.add(pmCrop);
    pmCrop.addActionListener(this);
    
    this.add(popup);

    addMouseListener(new MouseHandler());
    addMouseMotionListener(new MouseMotionHandler());
        
  }/*end of constructor*/
  
  private void initVariables()
  {
		tool   = PEN;
		pX     = -1; pY     = -1;
		pasteX = -1; pasteY = -1;		
		startX = -1; startY = -1;	endX   = -1; endY   = -1;
		cx1    = -1; cx2    = -1;	cy1    = -1; cy2    = -1;
		top    = -1; left   = -1;	width  = -1; height = -1;
		selX1  = -1; selX2  = -1;	selY1  = -1; selY2  = -1;
		cWidth  = -1;	cHeight = -1;
		zWidth  = -1;	zHeight = -1;
		scaleWidth  = -1;	scaleHeight = -1;
		curveCnt    = 0;  	
  }
    
  public void setColor(Color col)
  { color = col; }

  public void setFile(String f)
  { fname = f; }
  
  public String getFile()
  { return fname; }
  
  public void setParent(Frame p)
  { parent = p; }
  
  public void setNew(boolean n)
  { newFlag = n; }

  private void setPenTool()
  {
    tool=PEN;
    startX=0; startY=0; endX=0; endY=0;     	  
 	  newObject=false;
 	}
  	
  public void setSize(int w,int h)
  {  	
    cWidth  = w;
    cHeight = h;
    zWidth  = cWidth;
    zHeight = cHeight;
    super.setSize(cWidth,cHeight);
    repaint();
  }
  
  public void setSize(Dimension d)
  {
	  int pixels[] = new int[cWidth*cHeight];
	  try
	  {
		  PixelGrabber pg=new PixelGrabber(buffer,0,0,cWidth,cHeight,pixels,0,cWidth);
		  pg.grabPixels();
	  }
	  catch(Exception e)  { }
	  
	  Image newImage = createImage(new MemoryImageSource(cWidth,cHeight,pixels,0,cWidth));
	  
  	cWidth  = d.width;
  	cHeight = d.height;
    zWidth  = cWidth;
    zHeight = cHeight;
  	super.setSize(cWidth,cHeight);
  	
  	buffer = createImage(cWidth,cHeight);
  	tmpBuf = createImage(cWidth,cHeight);
  	
  	Graphics g1 = buffer.getGraphics();
  	Graphics g2 = tmpBuf.getGraphics();
  	g1.drawImage(newImage,0,0,this);
  	g2.drawImage(newImage,0,0,this);
  	
  	parent.validate();
  	repaint();
  }

  // ---- clear the shapes and color vectors to reset everything ----
  public void clear()
  {		/*upto 986*/
    startX = -1; startY = -1; endX = -1; endY = -1; pX = -1; pY = -1;
    if(buffer != null)
    {
    	Graphics b=buffer.getGraphics();
    	b.clearRect(0,0,cWidth,cHeight);
    }
    
    pmCut.setEnabled(false);
    PaintMagic.cutB.setEnabled(false);
    PaintMagic.edit_cut.setEnabled(false);
    
    pmCopy.setEnabled(false);
    PaintMagic.copyB.setEnabled(false);
    PaintMagic.edit_copy.setEnabled(false);
    
    if(!copyFlag)
    {
      pmPaste.setEnabled(false);
      PaintMagic.pasteB.setEnabled(false);
      PaintMagic.edit_paste.setEnabled(false);
    }
    
    pmClear.setEnabled(false);
    pmCrop.setEnabled(false);
 
    newObject = false;
    zoomFlag  = false;
    brushFlag = false;
    paintAll(getGraphics());
  }

  public void setTool(int toolType)
  {
    tool = toolType;
    newObject = true;
    brushFlag = false;
    
    String curr_tool="";
    
		pX     = -1; pY     = -1;
		pasteX = -1; pasteY = -1;		
		startX = -1; startY = -1;	endX   = -1; endY   = -1;
		cx1    = -1; cx2    = -1;	cy1    = -1; cy2    = -1;
		top    = -1; left   = -1;	width  = -1; height = -1;

    pmCut.setEnabled(false);
    PaintMagic.edit_cut.setEnabled(false);
    pmCopy.setEnabled(false);
    PaintMagic.edit_copy.setEnabled(false);
    if(!copyFlag)
    {
      pmPaste.setEnabled(false);
      PaintMagic.pasteB.setEnabled(false);
      PaintMagic.edit_paste.setEnabled(false);
    }
    pmClear.setEnabled(false);
    pmCrop.setEnabled(false);
    
    PaintMagic.cutB.setEnabled(false);
    PaintMagic.copyB.setEnabled(false);
    
    pasteX=0; pasteY=0;
    
    switch(tool)
    {
    	case IMAGE:
      	zoomFlag=false;
        tracker = new MediaTracker(this);
				int pixels[] = new int[1];
				int iw=0,ih=0;
				if(fname.endsWith(".pmg"))
				{
					File f = new File(fname);
					int i=0;
					
					try
					{
					  ObjectInputStream br=new ObjectInputStream(new FileInputStream(f));
					  iw=br.readInt();
					  ih=br.readInt();
					  pixels = new int[iw*ih];
					  for(i=0;i<pixels.length;i++) pixels[i]=br.readInt();
					}catch(Exception e)
					{	System.out.println("Exception while reading: " + e); }
					
					try
					{
					 img=createImage(new MemoryImageSource(iw,ih,pixels,0,iw));
           tracker.addImage(img,0);
					}catch(Exception e)
					{ System.out.println("Exception while creating image: " + e); }
				}
				else
				{
	        try
	        {
//	          tracker = new MediaTracker(this);
	          img = Toolkit.getDefaultToolkit().getImage(fname);
	          tracker.addImage(img,0);
	          tracker.waitForID(0);
	        }
	        catch (Exception e)
	        { System.out.println("Exception while loading image: " + e); }
	      }
	        
        if (!tracker.isErrorID(0))
        {
          cWidth = img.getWidth(this);
          cHeight = img.getHeight(this);
          zWidth = cWidth;
          zHeight = cHeight;
          clear();
          this.validate();
          setSize(cWidth,cHeight);
          curr_status = "Image Opened";
          return;
        }
        else
        {
          new MsgBox(parent,"ERROR!","Sorry!  This format is not supported.");
          curr_status = "Image Open - failed";
          setPenTool();
        }
        break;
      case SCALE:
        ScaleDialog sd = new ScaleDialog(parent,this.getSize());
        scaleWidth = 0; scaleHeight=0;
	      if(sd.status())
	      {
	      	Dimension d = sd.getNewSize();	      	
	      	if(sd.getWidthMeasure())
	      	{
	      		float sWidth = ((float)cWidth * ((float)d.width/100));
	      		scaleWidth = (int)sWidth;
	      	}
	      	else
	      	  scaleWidth = d.width;
	      	  
	      	if(sd.getHeightMeasure())
	      	{
	      	  float sHeight = (float)cHeight * ((float)d.height/100);
	      	  scaleHeight = (int)sHeight;
	      	}
	      	else
	      	  scaleHeight = d.height;
          curr_status = "Image scaled";
	      }
	      else
	        tool = NONE;
	      break;      
	    case P_ZOOM:
	    	zWidth = zWidth*2;
	    	zHeight = zHeight*2;
	    	zoomFlag=true;
        curr_tool = "Zoom In";
	    	break;
	    case N_ZOOM:
	    	zWidth = zWidth/2;
	    	zHeight = zHeight/2;
	    	zoomFlag=true;
        curr_tool = "Zoom Out";
	    	break;
	    case TEXT:
	     	FontDialog f = new FontDialog(parent,this.getFont());
	     	curr_tool = "Text Insertion";
	     	PaintMagic.status2.setText(curr_tool);
		   	if(f.isCancelled())
	     	{
	     	  setPenTool();
	     	  curr_tool = "Pencil (freehand drawing)";
	     	  return;
	     	}
	     	else
	     	{
	   	 	  setFont(f.getFnt());
	   	    txt = f.getTxt();
          curr_status = "Text Inserted";
	   	  }
	   	  break;
	   	case PEN:
        MediaTracker t = new MediaTracker(this);
        Toolkit tk = getToolkit();
        Dimension d = tk.getBestCursorSize(8,8);
        int colors = tk.getMaximumCursorColors();        
        curr_tool = "Pencil (freehand drawing)";
        if(!d.equals(new Dimension(0,0)) && (colors != 0))
        {
	      	Image ci = tk.getImage("gifs\\c_pencil.gif");
	      	t.addImage(ci,0);
	      	try{
	        	t.waitForID(0);
	        }catch(Exception ex) {}
	        
	        if(ci != null)
	        {
	        	try
	        	{
	        		Cursor penCursor = tk.createCustomCursor(ci,new Point(0,30),"pencil cursor");
	        		this.setCursor(penCursor);
	        	}
	        	catch(Exception e)
	        	{
	        		System.err.println("Unable to create custom cursor");
	        	}
	        }
	      }	      
      	break;
      case LINE:
        curr_tool = "Line";
        break;
      case BRUSH:
        curr_tool = "Air Brush";
        break;
      case POLYGON:
        curr_tool = "Polygon";
        break;
      case RECTANGLE:
        curr_tool = "Open Rectangle";
        break;
      case FILL_RECT:
        curr_tool = "Filled Rectangle";
        break;
      case RNDRECT:
        curr_tool = "Rounded Rectangle";
        break;
      case FILL_RNDRECT:
        curr_tool = "Filled Rounded Rectangle";
        break;
      case OVAL:
        curr_tool = "Ellipse";
        break;
      case FILL_OVAL:
        curr_tool = "Filled Ellipse";
        break;
      case CURVE:
        curr_tool = "Curve/Arc";
        curveCnt = -1;
        break;
      default:
      	setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
      	break;        
	  }
	        
    if(tool != P_ZOOM && tool != N_ZOOM)
    { zWidth=cWidth; zHeight=cHeight; zoomFlag = false; }
    
//    if(tool == PEN || tool==LINE || tool==BRUSH || tool == RECTANGLE || tool == RNDRECT || tool == OVAL || tool == TEXT || tool == POLYGON)
//      return;
    
    PaintMagic.status2.setText(curr_tool);
    repaint();
    
    if(zoomFlag)
      parent.validate();
  }

  // ---- the paint function ----
  public void paint(Graphics g)
  {    	
    if(tool != P_ZOOM && tool != N_ZOOM)
      super.setSize(cWidth,cHeight);
    int val=0;

  	if(newFlag)
  	{
  	  buffer = createImage(cWidth,cHeight);
    	tmpBuf = createImage(cWidth,cHeight);
    	newFlag=false;
    }	    
   	else
   	{
   		if(buffer == null)
  	    buffer = createImage(cWidth,cHeight);
      if(tmpBuf == null)
    	  tmpBuf = createImage(cWidth,cHeight);
	    if(tool == IMAGE) // || tool == FILTER) //|| tool == P_ZOOM || tool == N_ZOOM)
	    {
	  		buffer = createImage(cWidth,cHeight);
	  		tmpBuf = createImage(cWidth,cHeight);
	  	}
	  }
	  	
  	b = buffer.getGraphics();
  	b.setColor(color);
    t = tmpBuf.getGraphics();

    if(newObject && tool != IMAGE)
    {
      t.drawImage(buffer,0,0,this);
      t.setColor(color);
    }	
    		  	
    top    = Math.min(startX,endX);
    left   = Math.min(startY,endY);
    width  = Math.abs(endX - startX);
    height = Math.abs(endY - startY);

  	switch(tool)
  	{
  		case NONE:
  		  PaintMagic.status1.setText("Pointer (NONE)");
  		  break;
  		case SELECT:
  		  if(selectFlag)
  		  {
          float[] dashPattern = {10.0f,5.0f,10.0f,5.0f};
          Graphics2D t1 = (Graphics2D)t;
          t1.setStroke(new BasicStroke(2,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER,10.0f,dashPattern,0.0f));

		    	t1.setXORMode(getBackground());
			    top    = Math.min(selX1,selX2);
			    left   = Math.min(selY1,selY2);
			    width  = Math.abs(selX2 - selX1);
			    height = Math.abs(selY2 - selY1);
		      t1.drawRect(top,left,width,height);
		      t1.setPaintMode();

			    pmCut.setEnabled(true);
			    PaintMagic.cutB.setEnabled(true);
          PaintMagic.edit_cut.setEnabled(true);
			    pmCopy.setEnabled(true);
			    PaintMagic.copyB.setEnabled(true);
          PaintMagic.edit_copy.setEnabled(true);
			    if(!copyFlag)
			    {
			      pmPaste.setEnabled(false);
			      PaintMagic.pasteB.setEnabled(false);
            PaintMagic.edit_paste.setEnabled(false);
			    }
			    pmClear.setEnabled(true);
			    pmCrop.setEnabled(true);
			    curr_status = "Selection done";
			  }
  		  PaintMagic.status2.setText("Selection");
	      break;
  		case IMAGE:
        b.drawImage(img,0,0,this);          
  	    tool = NONE;
        break;
      case DISSOLVE:
    		fd  = new FilterDialog(parent,"Dissolve Filter",0,0);
    		val = fd.getVal();
    		if(val != 0)
    		{
      		fimg = createImage(new FilteredImageSource(buffer.getSource(), new DissolveFilter(val)));
      		b.drawImage(fimg,0,0,this);
    	  }
  	    tool = NONE;
    	  break;
    	case BLEACH:
    		fd  = new FilterDialog(parent,"Bleach Filter",0,0);
    		val = fd.getVal();
    		if(val != 0)
    		{
      		fimg = createImage(new FilteredImageSource(buffer.getSource(),new BleachFilter(val)));
      		b.drawImage(fimg,0,0,this);
    	  }
  	    tool = NONE;
    	  break;
      case BRIGHT:
    		fd  = new FilterDialog(parent,"Brightness",-100,0);
    		val = fd.getVal();
    		if(val != 0)
    		{
    		  fimg = createImage(new FilteredImageSource(buffer.getSource(),new BFilter(val)));
    		  b.drawImage(fimg,0,0,this);
    		}
	    	tool = NONE;
	    	break;
	    case COLOR:
    		cd = new ColorDialog(parent);
    		if(cd.status())
    		{
    			fimg = createImage(new FilteredImageSource(buffer.getSource(),new CFilter(cd.getColor())));
    		  b.drawImage(fimg,0,0,this);
    		}
    		tool = NONE;
	      break;
	    case CONTRAST:
        fimg = createImage(new FilteredImageSource(buffer.getSource(),new Contrast()));
        b.drawImage(fimg,0,0,this);
    		tool = NONE;
	      break;
	    case GRAYSCALE:		    
        fimg = createImage(new FilteredImageSource(buffer.getSource(),new GrayScale()));
        b.drawImage(fimg,0,0,this);
    		tool = NONE;
	      break;
      case INVERT:
        fimg = createImage(new FilteredImageSource(buffer.getSource(),new InvertFilter()));
        b.drawImage(fimg,0,0,this);
  	    tool = NONE;
        break;
      case SHADOW:
    		cd = new ColorDialog(parent);
    		if(cd.status())
    		{
          fimg = createImage(new FilteredImageSource(buffer.getSource(),new ShadowFilter(getSize().width, getSize().height, cd.getColor())));
          b.drawImage(fimg,0,0,this);
    		}
  	    tool = NONE;
        break;
      case BLUR:			    
		    float ninth = 1.0f / 9.0f;
		    float[] blurKernel = {
		        ninth, ninth, ninth,
		        ninth, ninth, ninth,
		        ninth, ninth, ninth };
  
	      cOp  = new ConvolveOp(new Kernel(3, 3, blurKernel),ConvolveOp.EDGE_NO_OP, null);
        biOp = (BufferedImageOp)cOp;

        createDestImg();

		    b.drawImage(destination,0,0,this);
		    t.drawImage(destination,0,0,this);
        tool=NONE;
        break;
      case SHARPEN:
		    float[] sharp = {
		        0f, -1f, 0f,
		        -1f, 5f, -1f,
		        0f, -1f, 0f };
		        
	      cOp  = new ConvolveOp(new Kernel(3, 3, sharp));
        biOp = (BufferedImageOp)cOp;

        createDestImg();

		    b.drawImage(destination,0,0,this);
		    t.drawImage(destination,0,0,this);
        tool = NONE;
        break;
      case POSTERIZE:        
		    short[] posterize = new short[256];
		    for (int i = 0; i < 256; i++)
		     { posterize[i] = (short)(i - (i % 32)); }
		
		    lOp  =  new LookupOp(new ShortLookupTable(0, posterize), null);
        biOp = (BufferedImageOp)lOp;
        
        createDestImg();

		    b.drawImage(destination,0,0,this);
		    t.drawImage(destination,0,0,this);
        tool = NONE;
        break;
      case WAVE:
        fimg = createImage(new FilteredImageSource(buffer.getSource(),new WaveFilter()));
        b.drawImage(fimg,0,0,this);
  	    tool = NONE;
        break;
      case SCALE:
        if(scaleWidth != 0 && scaleHeight != 0)
        {     	        
	        // can also use AreaAveragingScaleFilter - slow but better
	        ImageFilter filter = new ReplicateScaleFilter(scaleWidth,scaleHeight);	        
	        FilteredImageSource fis = new FilteredImageSource(buffer.getSource(),filter);
	        fimg = createImage(fis);
	        
	        buffer=createImage(scaleWidth,scaleHeight);
	        b = buffer.getGraphics();
	        
	        tmpBuf=createImage(scaleWidth,scaleHeight);
	        t = tmpBuf.getGraphics();
	        
	        this.setSize(scaleWidth,scaleHeight);
	        
	        b.drawImage(fimg,0,0,this);
	        validate();
        }
        tool = NONE;
        break;        
      case ROTATE:
        new MsgBox(parent,"WARNING","This tool is still under development");
/*        
		    RenderingHints rh = new RenderingHints(RenderingHints.KEY_INTERPOLATION,RenderingHints.VALUE_INTERPOLATION_BILINEAR);
		    
		    float[] rot = {
		    	0f,-1f,0f,
		    	1f,0f,0f,
		    	0f,0f,1f };
		        
//		    Graphics2D g2 = (Graphics2D)g;
		    
		    at = new AffineTransform();
		    at = AffineTransform.getRotateInstance(Math.PI / 2, cWidth/2, cHeight/2);
//			    at.setToTranslation(cWidth/2,cHeight/2);
//			    at.rotate(Math.PI/2);
//		    at.translate(-cWidth/2,-cHeight/2);
		    
		    atOp =  new AffineTransformOp(at, rh);
        biOp = (BufferedImageOp)atOp;
        

		    // create the source buffered image
		    source = new BufferedImage(buffer.getWidth(null), buffer.getHeight(null),BufferedImage.TYPE_INT_RGB);
		    gf = source.createGraphics();
		    gf.drawImage(buffer, 0, 0, null);
		
		    // create the destination (filtered) image
		    destination = biOp.filter(source, null);


//        createDestImg();
        
		    int temp=cWidth;
		    cWidth=cHeight;
		    cHeight=temp;
		    setSize(cWidth,cHeight);
		    b.clearRect(0,0,cWidth,cHeight);
		    t.clearRect(0,0,cWidth,cHeight);
//          setSize(getPreferredSize());
*/
		   
		    b.drawImage(buffer,cHeight,cWidth,cHeight,cWidth,0,0,cWidth,cHeight,this);
//		    t.drawImage(destination,0,0,this);
		    
        tool = NONE;
        break;        
      case CROP:
        if(selectFlag)
        {
		      left = Math.min(selX1,selX2);
			    top = Math.min(selY1,selY2);
			    width = Math.abs(selX2 - selX1);
			    height = Math.abs(selY2 - selY1);
	 
	        CropImageFilter f = new CropImageFilter(left,top,width,height);
	    		fimg = createImage(new FilteredImageSource(buffer.getSource(),f));
	    		
	    		cWidth=width; cHeight=height;
	    		setSize(width,height);
	    		buffer = createImage(width,height);
	    		b = buffer.getGraphics();
	        b.drawImage(fimg,0,0,this);
	        selectFlag=false;
	      }
        tool = NONE;
        break;
      case CUT:
        if(selectFlag)
        {
		      left = Math.min(selX1,selX2);
			    top = Math.min(selY1,selY2);
			    width = Math.abs(selX2 - selX1);
			    height = Math.abs(selY2 - selY1);
				  int pixels[] = new int[width*height];
				  try
				  {
					  PixelGrabber pg=new PixelGrabber(buffer,left,top,width,height,pixels,0,width);
					  pg.grabPixels();
					  Image copyImage = createImage(new MemoryImageSource(width,height,pixels,0,width));
					  
				    ImageSelection contents = new ImageSelection(copyImage);
				    clipboard.setContents(contents, null);
	
				    pmPaste.setEnabled(true);
				    PaintMagic.pasteB.setEnabled(true);
            PaintMagic.edit_paste.setEnabled(true);
				    copyFlag=true;
				    					  
  			    b.clearRect(left,top,width,height);
  			    t.clearRect(left,top,width,height);
  			    curr_status = "Selection Cut";
 					}
					catch(Exception e)
					{
						System.err.println("Error copying pixels: " + e);
					}			    			    
			  }
			  tool = NONE;
			  break;
      case COPY:
        if(selectFlag)
        {
		      left = Math.min(selX1,selX2);
			    top = Math.min(selY1,selY2);
			    width = Math.abs(selX2 - selX1);
			    height = Math.abs(selY2 - selY1);
				  int pixels[] = new int[width*height];
				  try
				  {
					  PixelGrabber pg=new PixelGrabber(buffer,left,top,width,height,pixels,0,width);
					  pg.grabPixels();
					  Image copyImage = createImage(new MemoryImageSource(width,height,pixels,0,width));
					  
				    ImageSelection contents = new ImageSelection(copyImage);
				    clipboard.setContents(contents, null);
	
				    pmPaste.setEnabled(true);
				    PaintMagic.pasteB.setEnabled(true);
            PaintMagic.edit_paste.setEnabled(true);
				    copyFlag=true;					  
      		  curr_status = "Selection Copied";
					}
					catch(Exception e)
					{
						System.err.println("Error copying pixels: " + e);
					}
			  }
			  tool = NONE;
			  break;
			case PASTE:
				Transferable contents = clipboard.getContents(this);
				
				if(contents != null && contents.isDataFlavorSupported(ImageSelection.ImageFlavor))
				{
					try
					{
						Image image;
						image = (Image)contents.getTransferData(ImageSelection.ImageFlavor);
						b.drawImage(image,pasteX,pasteY,this);
						t.drawImage(image,pasteX,pasteY,this);
      		  curr_status = "Selection Pasted";
					}
					catch(Exception e)
					{
						e.printStackTrace();
					}
				}
				tool = NONE;
				break;			  
      case P_ZOOM:
      case N_ZOOM:
        super.setSize(zWidth,zHeight);        
        g.drawImage(buffer,0,0,zWidth,zHeight,this);
   		  curr_status = "Image Zoomed";
        break;
  		case PEN:
        t.drawLine(startX,startY,endX,endY);
        b.drawLine(startX,startY,endX,endY);
        startX = endX;
        startY = endY;
        break;
      case BRUSH:
        if(brushFlag)
        {
	        Random r = new Random();
	        int brushCnt=0;
	        int i,j;
	        for(int k=0;k<30;k++)
	        {
	          i = r.nextInt(10);
	          j = r.nextInt(10);
	          if(brushCnt==0)
	          {
	            t.drawLine(startX+i,startY+j,startX+i,startY+j);
	            b.drawLine(startX+i,startY+j,startX+i,startY+j);
	            brushCnt++;
	          }
	          else if(brushCnt==1)
	          {
	            t.drawLine(startX+i,startY-j,startX+i,startY-j);
	            b.drawLine(startX+i,startY-j,startX+i,startY-j);
	            brushCnt++;
	          }            
	          else if(brushCnt==2)
	          {
	            t.drawLine(startX-i,startY+j,startX-i,startY+j);
	            b.drawLine(startX-i,startY+j,startX-i,startY+j);
	            brushCnt++;
	          }            
	          else if(brushCnt==3)
	          {
	            t.drawLine(startX-i,startY-j,startX-i,startY-j);
	            b.drawLine(startX-i,startY-j,startX-i,startY-j);
	            brushCnt=0;
	          }            
	        }
	        startX = endX;
	        startY = endY;
	      }
        break;
      case LINE:         
        if(newObject)
           t.drawLine(startX,startY,endX,endY);
        else
           b.drawLine(startX,startY,endX,endY);
      	break;
      case RECTANGLE:
        if(newObject) t.drawRect(top,left,width,height);
        else b.drawRect(top,left,width,height);
      	break;
      case FILL_RECT:
        if(newObject) t.fillRect(top,left,width,height);
        else b.fillRect(top,left,width,height);
        break;
      case RNDRECT:
        if(newObject) t.drawRoundRect(top,left,width,height,30,30);
        else b.drawRoundRect(top,left,width,height,30,30);
      	break;
      case FILL_RNDRECT:
        if(newObject) t.fillRoundRect(top,left,width,height,30,30);
        else b.fillRoundRect(top,left,width,height,30,30);
        break;      
      case OVAL:
        if(newObject) t.drawOval(top,left,width,height);
        else b.drawOval(top,left,width,height);
      	break;
      case FILL_OVAL:
        if(newObject) t.fillOval(top,left,width,height);
        else b.fillOval(top,left,width,height);
        break;
      case CURVE:
        if(curveCnt == -1) break;
        if(curveCnt==0)
          {
          	if(newObject)
	        	  t.drawLine(startX,startY,endX,endY);
            cx1=startX;
            cy1=startY;
            cx2=endX;
            cy2=endY;
          }
          else if(curveCnt<=2)
          {
            if(newObject)
            {
            	t.fillRect(cx1-3,cy1-3,6,6);
              t.fillRect(cx2-3,cy2-3,6,6);
            }
            Graphics2D t1 = (Graphics2D)t;
            Graphics2D b1 = (Graphics2D)b;
            if(newObject||curveCnt==1)
              t1.draw(new QuadCurve2D.Double(cx1,cy1,endX,endY,cx2,cy2));
            else
            {
            	b1.draw(new QuadCurve2D.Double(cx1,cy1,endX,endY,cx2,cy2));
              curveCnt=-1;
            }
          }
        break;
      case POLYGON:
        if(newObject)
          t.drawLine(pX,pY,endX,endY);
          b.drawLine(pX,pY,endX,endY);
      	break;
      case TEXT:
        if(txt != null)
        {
	        if(newObject)
	          t.drawString(txt,endX,endY);
	        else
	          b.drawString(txt,endX,endY);
	      }
        break;
    }  // End of switch-case

    if(tool != P_ZOOM && tool != N_ZOOM)
    {
	    if(newObject) g.drawImage(tmpBuf,0,0,this);
	    else g.drawImage(buffer,0,0,this);
    }
    
    if(tool==NONE)
    {
 		  PaintMagic.status2.setText("Pointer (NONE)");
    	setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }
    else if (tool != PEN)
      setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));

  }  // End of paint()
  

  public void update(Graphics g)
  {
    paint(g);
  }
  
  private void createDestImg()
  {
  	try
  	{  		
	    // create the source buffered image
	    source = new BufferedImage(buffer.getWidth(null), buffer.getHeight(null),BufferedImage.TYPE_INT_RGB);
	    gf = source.createGraphics();
	    gf.drawImage(buffer, 0, 0, null);
	
	    // create the destination (filtered) image
	    destination = biOp.filter(source, null);
	  }
	  catch(Exception e)
	  {
	  	System.out.println("Exception while creating buffered images: " + e);
	  }
  }
  
  public void lostOwnership(Clipboard clip, Transferable transferable)
	{
		PaintMagic.edit_paste.setEnabled(false);
		PaintMagic.pasteB.setEnabled(false);
		pmPaste.setEnabled(false);		
		copyFlag = false;
	}

  public void save(String fname)
  {
	  File f=new File(fname);
	  int iw=cWidth;
	  int ih=cHeight;
	  int pixels[] = new int[iw*ih];
	  try
	  {
		  PixelGrabber pg=new PixelGrabber(buffer,0,0,iw,ih,pixels,0,iw);
		  pg.grabPixels();
		  ObjectOutputStream bw=new ObjectOutputStream(new FileOutputStream(f));
		  bw.writeInt(iw);
		  bw.writeInt(ih);
		  for(int i=0;i<pixels.length;i++) bw.writeInt(pixels[i]);
	  }catch(Exception e)
	  { System.out.println("Exception while saving: " + e); }
	}
	
	public void printCanvas()
	{
    PrinterJob printJob = PrinterJob.getPrinterJob();
    printJob.setPrintable(this);
    if (printJob.printDialog())
    {
      try
      {
        printJob.print();  
      } catch (Exception ex)
      { ex.printStackTrace(); }
    }
  }
			
  public int print(Graphics g, PageFormat pf, int pi) throws PrinterException
  {
    if (pi >= 1)
    {
      return Printable.NO_SUCH_PAGE;
    }
	  paint(g);
    return Printable.PAGE_EXISTS;
  }
  
  public void actionPerformed(ActionEvent e)
  {
  	String s = e.getActionCommand();
  	if(s.equals("Clear"))
  	{
	    int top    = Math.min(selX1,selX2);
	    int left   = Math.min(selY1,selY2);
	    int width  = Math.abs(selX2 - selX1);
	    int height = Math.abs(selY2 - selY1);

	    Graphics g = getGraphics();
	    Graphics b = buffer.getGraphics();
	    Color    c = getBackground();
	    g.setColor(c);
	    b.setColor(c);
      g.fillRect(top,left,width,height);
      b.fillRect(top,left,width,height);
      tool = NONE;
      repaint();
    }
    else if(s.equals("Crop"))
    {
    	tool = CROP;
    	repaint();
    }
    else if(s.equals("Cut"))
    {
    	tool = CUT;
    	repaint();
    }
    else if(s.equals("Copy"))
    {
    	tool = COPY;
    	repaint();
    }
    else if(s.equals("Paste"))
    {
    	tool = PASTE;
    	repaint();
    }
  }
  
  static Frame getFrame(Component c)
  {
  	while((c = c.getParent()) != null)
  	{
  		if(c instanceof Frame)
  		  return (Frame)c;
  	}
  	return null;
  }
  

  public void undo()
  {
  }

  public void redo()
  {
  }
  
  public void selectAll()
  {
  	selX1 = 0;
  	selY1 = 0;
  	selX2 = cWidth;
  	selY2 = cHeight;
  	selectFlag = true;
  	newObject = true;
  	tool = SELECT;
  	repaint();
  }
  
  public void clearSelect()
  {
  	selX1 = 0; selX2 = 0;
  	selY1 = 0; selY2 = 0;
  	selectFlag = false;
  	newObject = false;
  	
    pmCut.setEnabled(false);
    PaintMagic.cutB.setEnabled(false);
    PaintMagic.edit_cut.setEnabled(false);
    
    pmCopy.setEnabled(false);
    PaintMagic.copyB.setEnabled(false);
    PaintMagic.edit_copy.setEnabled(false);
    
    if(!copyFlag)
    {
      pmPaste.setEnabled(false);
      PaintMagic.pasteB.setEnabled(false);
      PaintMagic.edit_paste.setEnabled(false);
    }
    else
    {
      pmPaste.setEnabled(true);
      PaintMagic.pasteB.setEnabled(true);
      PaintMagic.edit_paste.setEnabled(true);
    }
    
    pmClear.setEnabled(false);
    pmCrop.setEnabled(false);
  	tool = NONE;
  	repaint();
  }
   	

  class MouseHandler extends MouseAdapter
  {
    // ---- mouse click event
    public void mouseClicked(MouseEvent e)
    {
    	if(e.getModifiers() == InputEvent.BUTTON3_MASK)
    	{
    	  popup.show(MyCanvas.this,e.getX(),e.getY());
    	  pasteX = e.getX();
    	  pasteY = e.getY();
    	}      
    }

    // ---- mouse pressed event
    public void mousePressed(MouseEvent e)
    {
    	if(e.getModifiers() != InputEvent.BUTTON1_MASK) return;
      
      if(tool == POLYGON)
      {
        pX = (pX == -1)? e.getX():endX;
        pY = (pY == -1)? e.getY():endY;
        endX = e.getX();
        endY = e.getY();
        repaint();
        return;
      }
      
      if(tool == TEXT)
      {
      	endX = e.getX();
      	endY = e.getY();
      	newObject = false;
      	repaint();
      	newObject = true;
      	return;
      }

      if(tool == SELECT)
      {
      	selX1=e.getX();
      	selY1=e.getY();
      	return;
      }

      startX = e.getX();
      startY = e.getY();
      curveFlag = false;
      brushFlag = true;
    }

    // ---- mouse released event
    public void mouseReleased(MouseEvent e)
    {
    	if(e.getModifiers() != InputEvent.BUTTON1_MASK) return;

      if(tool == POLYGON) return;

      if(tool == SELECT)
      {
      	selX2=e.getX();
      	selY2=e.getY();
      	repaint();
      	return;
      }

      endX=e.getX();
      endY=e.getY();
      
      curveFlag=(tool==CURVE && curveCnt==0)?false:true;
      
      repaint();
      curveCnt++;
      newObject = false;
    }
    
    public void mouseExited(MouseEvent e)
    {
    	PaintMagic.status3.setText("  OOPS!");
    }
    
    public void mouseEntered(MouseEvent e)
    {
    	PaintMagic.status1.setText(curr_status);
    }
  }

  class MouseMotionHandler extends MouseMotionAdapter
  {
    // mouse dragged event
    public void mouseDragged(MouseEvent e)
    {
    	if(e.getModifiers() != InputEvent.BUTTON1_MASK) return;

      if(tool == POLYGON) return;

      if(tool==CURVE && curveCnt==-1) curveCnt=0;

      if(tool == SELECT)
      {
      	selectFlag=true;
      	selX2=e.getX();
      	selY2=e.getY();
       	repaint();
      	return;
      }
      endX=e.getX();
      endY=e.getY();
      newObject = true;
      selectFlag=false; 
    	PaintMagic.status3.setText("  (" + e.getX() + "," + e.getY() + ")");
      repaint();
    }
    
    public void mouseMoved(MouseEvent e)
    {
    	if(tool == TEXT)
    	{
    		endX = e.getX();
    		endY = e.getY();
    		newObject = true;
    		repaint();
    	}
    	
    	PaintMagic.status3.setText("  (" + e.getX() + "," + e.getY() + ")");
    }
    
  }
}   /* ----- End of class  -  MyCanvas  ----- */


/***************************************************************************/
/* CLASS:  ImageSelection                                                  */
/***************************************************************************/
class ImageSelection implements Transferable, ClipboardOwner
{
	static public DataFlavor ImageFlavor;	
	private DataFlavor[] flavors = {ImageFlavor};
	private Image image;
	
	static
	{
		try
		{
			ImageFlavor = new DataFlavor(Class.forName("java.awt.Image"),"AWT Image");
		}
		catch(ClassNotFoundException e)
		{
			e.printStackTrace();
		}
	}
	
	public ImageSelection(Image image)
	{
		this.image = image;
	}
	
	public synchronized DataFlavor[] getTransferDataFlavors()
	{
		return flavors;
	}
	
	public boolean isDataFlavorSupported(DataFlavor flavor)
	{
		return flavor.equals(ImageFlavor);
	}
	
	public synchronized Object getTransferData(DataFlavor flavor)
	   throws UnsupportedFlavorException, IOException
	{
		if(flavor.equals(ImageFlavor))
		  return image;
		else throw new UnsupportedFlavorException(flavor);
	}
	
	public void lostOwnership(Clipboard c, Transferable t)
	{ }
}

/***************************************************************************/
/* CLASS:  ColorDialog                                                     */
/***************************************************************************/
class ColorDialog extends Dialog implements AdjustmentListener, ActionListener, TextListener
{
	private Scrollbar redSB, greenSB, blueSB;
	private TextField redTF, greenTF, blueTF;
	private TextArea tf = new TextArea("",3,10,TextArea.SCROLLBARS_NONE);
	private Color newColor = new Color(0,0,0);
  private Button[] b = new Button[16];
  private int red,green,blue;    
  private boolean colorSet=false;
	
	ColorDialog(Frame owner)
	{
		super(owner,"Color Chooser",true);
		
		setSize(350,270);
		setLocation((owner.getSize().width-getSize().width)/2,(owner.getSize().height-getSize().height)/2);		
    setLayout(new BorderLayout(10,10));

    // add the text field which changes background
		tf.setEnabled(false);
		tf.setBackground(newColor);
    add("North",tf);

    // create the color buttons and its panel
    Panel buttonPanel = new Panel();
    buttonPanel.setLayout(new GridLayout(4,4,10,10));
    for(int j=0;j<16;j++)
    {
      b[j] = new Button(" ");
      b[j].addActionListener(this);
      buttonPanel.add(b[j]);
    }

    b[0].setBackground(Color.black);
    b[1].setBackground(Color.darkGray);
    b[2].setBackground(Color.gray);
    b[3].setBackground(Color.lightGray);
    b[4].setBackground(Color.blue);
    b[5].setBackground(new Color(120,170,220));
    b[6].setBackground(Color.cyan);
    b[7].setBackground(Color.green);
    b[8].setBackground(new Color(170,0,200));
    b[9].setBackground(new Color(170,100,100));
    b[10].setBackground(Color.magenta);
    b[11].setBackground(Color.red);
    b[12].setBackground(Color.orange);
    b[13].setBackground(Color.pink);
    b[14].setBackground(Color.yellow);
    b[15].setBackground(Color.white);       
    
		// create the 'RED', 'GREEN' and 'BLUE' labels
		Label redL = new Label("RED");
		Label greenL = new Label("GREEN");
		Label blueL = new Label("BLUE");
		
		// create the scrollbars representing RGB
		redSB = new Scrollbar(Scrollbar.VERTICAL,0,1,0,255);
		greenSB = new Scrollbar(Scrollbar.VERTICAL,0,1,0,255);
		blueSB = new Scrollbar(Scrollbar.VERTICAL,0,1,0,255);
		
		redSB.addAdjustmentListener(this);
		greenSB.addAdjustmentListener(this);
		blueSB.addAdjustmentListener(this);
		
		// create the TextField to hold RGB value
		redTF = new TextField("0",3);
		greenTF = new TextField("0",3);
		blueTF = new TextField("0",3);
		
		redTF.addTextListener(this);
		greenTF.addTextListener(this);
		blueTF.addTextListener(this);
				
    // create panels for each component and add them accordingly
		GridBagConstraints c = new GridBagConstraints();

    // r1, r2 & r3
		Panel r1 = new Panel();
		r1.add(redL);
		Panel r2 = new Panel();
		r2.add(redSB);
		Panel r3 = new Panel();
		r3.add(redTF);
		
		// Red Panel
		Panel redP = new Panel(new GridBagLayout());
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.weighty=0.0;
		redP.add(r1,c);
		c.gridheight=2;
		c.weighty=1.0;
		redP.add(r2,c);
		c.gridheight=1;
		c.weighty=0.0;
		redP.add(r3,c);
		
		// g1, g2 & g3
		Panel g1 = new Panel();
		g1.add(greenL);
		Panel g2 = new Panel();
		g2.add(greenSB);
		Panel g3 = new Panel();
		g3.add(greenTF);

		// Green Panel
		Panel greenP = new Panel(new GridBagLayout());
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.weighty=0.0;
		greenP.add(g1,c);
		c.gridheight = 2;
		c.weighty=1.0;
		greenP.add(g2,c);
		c.gridheight=1;
		c.weighty=0.0;
		greenP.add(g3,c);
		
		// b1, b2 & b3
		Panel b1 = new Panel();
		b1.add(blueL);
		Panel b2 = new Panel();
		b2.add(blueSB);
		Panel b3 = new Panel();
		b3.add(blueTF);

		// Blue Panel
		Panel blueP = new Panel(new GridBagLayout());
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.weighty=0.0;
		blueP.add(b1,c);
		c.gridheight = 2;
		c.weighty=1.0;
		blueP.add(b2,c);
		c.gridheight=1;
		c.weighty=0.0;
		blueP.add(b3,c);
		   
		// The RGB Panel which hold the previous three panels
	Panel rgbP = new Panel(new GridLayout(1,3,5,5));
    rgbP.add(redP);
    rgbP.add(greenP);
    rgbP.add(blueP);
    

    // create a panel to hold the color buttons and RGB panel
    // and add it to the center
    Panel row2 = new Panel(new GridLayout(1,2,10,10));
    row2.add(buttonPanel);
    row2.add(rgbP);
		add("Center",row2);


    // create the 'done' and 'cancel' buttons and add them to 'South'
		Button doneB = new Button("DONE");
		Button cancelB = new Button("CANCEL");
		doneB.addActionListener(this);
		cancelB.addActionListener(this);
		Panel bp = new Panel();
		bp.setLayout(new FlowLayout(FlowLayout.CENTER));
		bp.add(doneB); bp.add(cancelB);
		add("South",bp);


		addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{ dispose(); }
		});
		
				
  	show();
	}
	
	public Color getColor()
	{
		Color c = new Color(redSB.getValue(),greenSB.getValue(),blueSB.getValue());
		return(c);
	}
	
	public boolean status()
	{
		return colorSet;
	}

	public void adjustmentValueChanged(AdjustmentEvent e)
	{
		Adjustable a = e.getAdjustable();
		if(a.equals(redSB))
		  redTF.setText(""+redSB.getValue());
		else if(a.equals(greenSB))
		  greenTF.setText(""+greenSB.getValue());
		else if(a.equals(blueSB))
		  blueTF.setText(""+blueSB.getValue());
		newColor = new Color(redSB.getValue(),greenSB.getValue(),blueSB.getValue());
		tf.setBackground(newColor);
	}
	
	public void actionPerformed(ActionEvent e)
	{
		String s = e.getActionCommand();
		if(s.equals("CANCEL"))
		{
			colorSet=false;
		  dispose();
		}
		else if(s.equals("DONE"))
		{
			colorSet=true;
		  dispose();
		}
		  
    Object source = e.getSource();
    for(int i=0;i<16;i++)
      {
        if(source==b[i])
         {
           Color c1 = b[i].getBackground();
           red = c1.getRed();
           green = c1.getGreen();
           blue = c1.getBlue();
           
           redSB.setValue(red);
           greenSB.setValue(green);
           blueSB.setValue(blue);
           
           redTF.setText(""+red);
           greenTF.setText(""+green);
           blueTF.setText(""+blue);
           
           tf.setBackground(c1);
         }
      }
	}
	public void textValueChanged(TextEvent e)
	{
		try
		{
	  	if((redTF.getText()).equals(""))
	  	  redTF.setText(Integer.toString(redSB.getValue()));
	  	else if((greenTF.getText()).equals(""))
	  	  greenTF.setText(Integer.toString(greenSB.getValue()));
	  	else if((blueTF.getText()).equals(""))
	  	  blueTF.setText(Integer.toString(blueSB.getValue()));

			if((redTF.getText() != null) && (greenTF.getText() != null) && (blueTF.getText() != null))
			{
				red = Integer.parseInt(redTF.getText());
				green = Integer.parseInt(greenTF.getText());
				blue = Integer.parseInt(blueTF.getText());
				
		    redSB.setValue(red);
		    greenSB.setValue(green);
		    blueSB.setValue(blue);
		
				newColor = new Color(red,green,blue);
				tf.setBackground(newColor);
			}
	  }catch(Exception e2)
	  {
	  }
	}
}  /* ---- End of class - ColorDialog ---- */
		
/***************************************************************************/
/* CLASS:  AboutDialog                                                     */
/***************************************************************************/
class AboutDialog extends Dialog implements ActionListener
{
	Image img;
	
	AboutDialog(Frame owner)
	{
		super(owner,"About PaintMagiK 2.0 . . .",true);
		
		setSize(400,200);
		setLocation((owner.getSize().width-this.getSize().width)/2,(owner.getSize().height-this.getSize().height)/2);
		setLayout(new BorderLayout());
		setResizable(false);
		
		img = Toolkit.getDefaultToolkit().getImage("gifs\\duke.gif");
		
//		Button b = new Button("Details");
//		b.setBackground(Color.gray);
//		add("South",b);
		
    addWindowListener(new WindowAdapter()
    {
    	public void windowClosing(WindowEvent e)
    	{	dispose(); }
    });
    
    show();
	}
	
  public void paint(Graphics g)
  {
  	int w = getSize().width;
  	int h = getSize().height;
  	
    Graphics2D g2 = (Graphics2D)g;
    Rectangle2D r = new Rectangle2D.Float(0, 0, w, h);
    GradientPaint gp = new GradientPaint(0, 0, Color.white, w, h, Color.gray, true);
    g2.setPaint(gp);
    g2.fill(r);
    
    g2.drawImage(img,10,60,this);

    g2.setColor(Color.black);
    g2.setFont(new Font("Arial",Font.BOLD,32));
    g2.drawString("Paint-MagiK 2.0",150,h/3);
    g2.setColor(Color.gray);
    g2.setFont(new Font("Courier",Font.BOLD,28));
    g2.drawString("by",w/2+40,h/2+5);
    g2.setColor(Color.darkGray); //new Color(0,127,127));
    g2.setFont(new Font("Times New Roman",Font.BOLD,20));
    g2.drawString("SREEDHARA & SUBRAMANYAM",75,h-50);
  }
  
  public void update(Graphics g)
  {
  	Graphics g2 =(Graphics2D)g;
  	paint(g2);
  }
	
	public void actionPerformed(ActionEvent e)
	{
		dispose();
	}
}

/***************************************************************************/
/* CLASS:  MsgBox                                                          */
/***************************************************************************/
class MsgBox extends Dialog implements ActionListener
{
	MsgBox(Frame owner,String title,String msg)
	{
		super(owner,title,true);
		
		setSize(250,100);
		setLocation((owner.getSize().width-this.getSize().width)/2,(owner.getSize().height-this.getSize().height)/2);
    setLayout(new GridLayout(2,1));
    

    Label head = new Label(msg);
    add(head);
		
    Button okB = new Button("  OK  ");    
    okB.addActionListener(this);
    Panel buttonP = new Panel(new FlowLayout(FlowLayout.CENTER));
    buttonP.add(okB);
    add(buttonP);
    
    addWindowListener(new WindowAdapter()
    {
    	public void windowClosing(WindowEvent e)
    	{	dispose(); }
    });
    
    show();
  }
  
  public void actionPerformed(ActionEvent e)
  {
  	dispose();
  }
}


/***************************************************************************/
/* CLASS:  ScaleDialog                                                     */
/***************************************************************************/
class ScaleDialog extends Dialog implements ActionListener, ItemListener
{
	boolean sizeSet = false;
	TextField widthT, heightT;
  Choice measureChooser1 = new Choice();/*COMBOBOX*/
  Choice measureChooser2 = new Choice();
  Dimension cSize;
	
	ScaleDialog(Frame owner, Dimension currentSize)
	{
		super(owner,"Scale Image",true);
		
		cSize = currentSize;

		setSize(350,160);
		setLocation((owner.getSize().width-this.getSize().width)/2,(owner.getSize().height-this.getSize().height)/2);
    setLayout(new GridLayout(4,1));
    
    Label head = new Label("Enter the scale size: ");
    
    Label widthL = new Label("Width :");
    Label heightL = new Label("Height:");
    
    widthT = new TextField("100");  //String.valueOf(currentSize.width));
    heightT = new TextField("100"); //String.valueOf(currentSize.height));
    
    measureChooser1.add("Percent");
    measureChooser1.add("Pixels");    
    
    measureChooser2.addItem("Percent");
    measureChooser2.addItem("Pixels");
    
    measureChooser1.addItemListener(this);
    measureChooser2.addItemListener(this);

    Panel p1 = new Panel(new FlowLayout(FlowLayout.CENTER));
    p1.add(widthL);
    p1.add(widthT);
    p1.add(measureChooser1);
    
    Panel p2 = new Panel(new FlowLayout(FlowLayout.CENTER));
    p2.add(heightL);
    p2.add(heightT);
    p2.add(measureChooser2);
    
    Panel buttonPanel = new Panel(new FlowLayout(FlowLayout.CENTER));
    Button okB = new Button("  OK  ");
    okB.addActionListener(this);
    Button cancelB = new Button("CANCEL");
    cancelB.addActionListener(this);
    buttonPanel.add(okB);
    buttonPanel.add(cancelB);
    
		add(head);
		add(p1);
		add(p2);
		add(buttonPanel);
		
    addWindowListener(new WindowAdapter()
    {
    	public void windowClosing(WindowEvent e)
    	{ dispose(); }
    });
    
		show();
	}
	
  public Dimension getNewSize()
  {
  	int width = Integer.parseInt(widthT.getText());
  	int height = Integer.parseInt(heightT.getText());
  	Dimension d = new Dimension(width,height);
  	return d;
  }

  public boolean status()
  {
  	return sizeSet;
  }
  
  public boolean getWidthMeasure()
  {
  	if(measureChooser1.getSelectedItem().equals("Percent"))
  	  return true;
  	else
  	  return false;
  }
  
  public boolean getHeightMeasure()
  {
  	if(measureChooser2.getSelectedItem().equals("Percent"))
  	  return true;
  	else
  	  return false;
  }
  	
	public void actionPerformed(ActionEvent e)
	{
		String s = e.getActionCommand();
		if(s.equals("CANCEL"))
		{
			sizeSet=false;
		  dispose();
		}
		else if(s.equals("  OK  "))
		{
			sizeSet=true;
		  dispose();
		}
	}
	
	public void itemStateChanged(ItemEvent e)
	{
		Object s = e.getSource();
		if(s.equals(measureChooser1))
		{
			if(measureChooser1.getSelectedItem().equals("Pixels"))
			  widthT.setText(String.valueOf(cSize.width));
			else
			  widthT.setText("100");
		}
		else if(s.equals(measureChooser2))
		{
			if(measureChooser2.getSelectedItem().equals("Pixels"))
			  heightT.setText(String.valueOf(cSize.height));
			else
			  heightT.setText("100");
		}
	}
}  /* ---- End of ScaleDialog ---- */


/***************************************************************************/
/* CLASS:  SizerDialog                                                     */
/***************************************************************************/
class SizerDialog extends Dialog implements ActionListener
{
  TextField widthText = new TextField("",3);
  TextField heightText = new TextField("",3);
	boolean sizeSet = false;
  
	SizerDialog(Frame owner, Dimension currentSize)
	{
		super(owner,"Canvas Resize",true);

		setSize(350,160);
		setLocation((owner.getSize().width-this.getSize().width)/2,(owner.getSize().height-this.getSize().height)/2);
    setLayout(new GridLayout(3,1));
    

    Label headLabel = new Label("  Enter new canvas size (in Pixels):");
    add(headLabel);
    

    Panel widthPanel = new Panel(new FlowLayout(FlowLayout.LEFT));
    Panel heightPanel = new Panel(new FlowLayout(FlowLayout.LEFT));

    Label widthLabel = new Label("Width: ");
    Label heightLabel = new Label("Height: ");        
    
    widthPanel.add(widthLabel); widthPanel.add(widthText);
    heightPanel.add(heightLabel); heightPanel.add(heightText);
    
    Panel row2 = new Panel(new GridLayout(1,2));
    row2.add(widthPanel);
    row2.add(heightPanel);
    
    add(row2);
        
    Button doneB = new Button("DONE");
    doneB.addActionListener(this);
    Button cancelB = new Button("CANCEL");
    cancelB.addActionListener(this);
    
    Panel buttonP = new Panel(new FlowLayout(FlowLayout.CENTER));
    buttonP.add(doneB);
    buttonP.add(cancelB);
    
    add(buttonP);
  
    addWindowListener(new WindowAdapter()
    {
    	public void windowClosing(WindowEvent e)
    	{ dispose(); }
    });
    
    widthText.setText(String.valueOf(currentSize.width));
    heightText.setText(String.valueOf(currentSize.height));
    
    show();    
  }
  
  public Dimension getNewSize()
  {
  	int width = Integer.parseInt(widthText.getText());
  	int height = Integer.parseInt(heightText.getText());
  	Dimension d = new Dimension(width,height);
  	return d;
  }

  public boolean status()
  {
  	return sizeSet;
  }

	public void actionPerformed(ActionEvent e)
	{
		String s = e.getActionCommand();
		if(s.equals("CANCEL"))
		{
			sizeSet=false;
		  dispose();
		}
		else if(s.equals("DONE"))
		{
			sizeSet=true;
		  dispose();
		}
	}
  
}  /* ---- End of class - SizeDialog ---- */


/***************************************************************************/
/* CLASS:  FontDialog                                                      */
/***************************************************************************/
class FontDialog extends Dialog implements ActionListener
{
	
	java.awt.List fontList = new java.awt.List();
	java.awt.List styleList = new java.awt.List();
	java.awt.List sizeList = new java.awt.List();
	TextField text = new TextField("",40);
	String styleNames[] = {"Plain","Bold","Italic","Bold Italic"};
	String sizeNames[]  = {"10","12","14","18","24","36","72"};
	int styles[] = {Font.PLAIN,Font.BOLD,Font.ITALIC,Font.BOLD+Font.ITALIC};
	int sizes[] = {10,12,14,18,24,36,72};
	
	String fontName;
	int fontStyle;
	int fontSize;
	Font newFont;
	
	boolean cancelled = false;
	
	public FontDialog(Frame parent,Font currentFont)
	{
		super(parent,"Text Effects:",true);
		setSize(525,210);
		setLocation((parent.getSize().width-getSize().width)/2,(parent.getSize().height-getSize().height)/2);
		setBackground(Color.lightGray);
		setForeground(Color.black);
		
		newFont = currentFont;
		fontName = newFont.getName();
		fontStyle = newFont.getStyle();
		fontSize = newFont.getSize();

		String FontList[];
		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		FontList = ge.getAvailableFontFamilyNames();/*GET ALL FONT'S NAMES*/
		for(int i=0;i<FontList.length;i++)
		  fontList.add(FontList[i]);
		  
		for(int i=0;i<styleNames.length;i++)
		  styleList.add(styleNames[i]);
		  
		for(int i=0;i<sizeNames.length;i++)
		  sizeList.add(sizeNames[i]);
		  
		setupPanels();
		
		addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{ dispose(); }
		});
		
		show();
	}
	
	void setupPanels()
	{
		Panel mainPanel = new Panel();
		mainPanel.setLayout(new GridLayout(1,3));
		
		Font plainFont = new Font("Helvetica",Font.PLAIN,12);
		Font boldFont = new Font("Helvetica",Font.BOLD,12);
		
		Panel fontPanel = new Panel(new BorderLayout());
		Label fontLabel = new Label("Font: ");
		fontPanel.add("North",fontLabel);
		fontPanel.add("Center",fontList);
		
		Panel stylePanel = new Panel(new BorderLayout());
		Label styleLabel = new Label("Style: ");
		stylePanel.add("North",styleLabel);
		stylePanel.add("Center",styleList);
		
		Panel sizePanel = new Panel(new BorderLayout());
		Label sizeLabel = new Label("Size: ");
		sizePanel.add("North",sizeLabel);
		sizePanel.add("Center",sizeList);
		
		mainPanel.add(fontPanel);
		mainPanel.add(stylePanel);
		mainPanel.add(sizePanel);
		mainPanel.setFont(plainFont);

		
		Label textLabel = new Label("Text:");
		textLabel.setFont(boldFont);
		Panel textPanel = new Panel(new FlowLayout());
		textPanel.add(textLabel);
		textPanel.add(text);
				
		Panel buttonPanel = new Panel(new FlowLayout());
		Button selectButton = new Button("  OK  ");
		Button cancelButton = new Button("CANCEL");
		selectButton.addActionListener(this);
		cancelButton.addActionListener(this);
		buttonPanel.add(selectButton);
		buttonPanel.add(cancelButton);
		buttonPanel.setFont(boldFont);
		
		Panel southPanel = new Panel(new GridLayout(2,1));
		southPanel.add(textPanel);
		southPanel.add(buttonPanel);
		
		add("Center",mainPanel);
		add("South",southPanel);
	}
	
	void updateNewFont()
	{
		if(fontList.getSelectedIndex() != -1)
		  fontName = fontList.getSelectedItem();
		if(styleList.getSelectedIndex() != -1)
		  fontStyle = styles[styleList.getSelectedIndex()];
		if(sizeList.getSelectedIndex() != -1)
		  fontSize = sizes[sizeList.getSelectedIndex()];
		newFont = new Font(fontName,fontStyle,fontSize);
	}
	
	String getTxt()
	{
		if(text.getText().equals(""))
		  return "PaintMagic";
		else
		  return text.getText();
	}
	
	Font getFnt()
	{
		return newFont;
	}
	
	boolean isCancelled()
	{
		return cancelled;
	}
		
	public void actionPerformed(ActionEvent e)
	{
		String s=e.getActionCommand();
		if(s.equals("  OK  "))
		{
			updateNewFont();
			cancelled=false;
			setVisible(false);
		}
		else if(s.equals("CANCEL"))
		{
			cancelled = true;
		  dispose();
		}
	}
		
}


/***************************************************************************/
/* CLASS:  FilterDialog                                                    */
/***************************************************************************/
class FilterDialog extends Dialog implements AdjustmentListener, ActionListener
{
  Scrollbar sb;
  Label lbl2 = new Label("   ");
  int sbValue;
  int minVal;

	FilterDialog(Frame owner,String title,int Min,int Init)
	{
		super(owner,title,true);
		
		minVal = Init;
		sb = new Scrollbar(Scrollbar.HORIZONTAL,Init,1,Min,101);
		Label lbl1 = new Label(title + " Value: ");
		Button okB = new Button(" OK ");
		Button cancelB = new Button("CANCEL");
			
		setSize(250,115);
		setLayout(new GridLayout(3,1));
//		setBackground(Color.white);
		setLocation((owner.getSize().width-getSize().width)/2,(owner.getSize().height-getSize().height)/2);
		
		Panel p1 = new Panel();
		p1.setLayout(new FlowLayout(FlowLayout.LEFT));
		p1.add(lbl1);
		p1.add(lbl2);
		Panel p2 = new Panel();
		p2.add(okB);
		p2.add(cancelB);

		add(p1);
		add(sb);
		add(p2);
		
		sb.addAdjustmentListener(this);
		okB.addActionListener(this);
		cancelB.addActionListener(this);
		
		addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{ sbValue=0; dispose(); }
		});
		
		update();
		show();
	}
	
	public void actionPerformed(ActionEvent e)
	{
		String s=e.getActionCommand();
		if(s.equals("CANCEL"))
		{
		  sbValue=minVal;
		  dispose();
		}
		else
		{
			update();
		  dispose();
		}
	}
	
	void update()
	{
		sbValue = sb.getValue();
		lbl2.setText("" + sbValue);
	}
		
	public void adjustmentValueChanged(AdjustmentEvent e)
	{	update();	}
	
	int getVal()
	{	return sbValue;	}
	
}


/***************************************************************************/
/* CLASS:  BFilter   --  Brightness Filter                                 */
/***************************************************************************/
class BFilter extends RGBImageFilter
{
  int brightness;

  public BFilter(int b)
  {
    brightness = b;
    canFilterIndexColorModel = true;
  }

  public int filterRGB(int x, int y, int rgb)
  {
    // Get the individual colors
    int r = (rgb >> 16) & 0xff;
    int g = (rgb >> 8) & 0xff;
    int b = (rgb >> 0) & 0xff;

    // Calculate the brightness
    r += (brightness * r) / 100;
    g += (brightness * g) / 100;
    b += (brightness * b) / 100;

    // Check the boundaries
    r = Math.min(Math.max(0, r), 255);
    g = Math.min(Math.max(0, g), 255);
    b = Math.min(Math.max(0, b), 255);

    // Return the result
    return (rgb & 0xff000000) | (r << 16) | (g << 8) | (b << 0);
  }
}


/***************************************************************************/
/* CLASS:  AFilter  --  Alpha Filter                                       */
/***************************************************************************/
class AFilter extends RGBImageFilter
{
  int alphaLevel;

  public AFilter(int alpha)
  {
    alphaLevel = alpha;
    canFilterIndexColorModel = true;
  }

  public int filterRGB(int x, int y, int rgb)
  {
    // Adjust the alpha value
    int alpha = (rgb >> 24) & 0xff;
    alpha = (alpha * alphaLevel) / 255;

    // Return the result
    return ((rgb & 0x00ffffff) | (alpha << 24));
  }
}

class DissolveFilter extends RGBImageFilter
{
  private int alpha;

  public DissolveFilter(int alpha) 
  {
    canFilterIndexColorModel = true;
    if(alpha<0 || alpha>255)
      throw new IllegalArgumentException("Bad Alpha");
    this.alpha = alpha;
  }

  public int filterRGB(int x, int y, int rgb) 
  {
    DirectColorModel cm = (DirectColorModel)ColorModel.getRGBdefault();
    int alpha = cm.getAlpha(rgb);
    int red   = cm.getRed(rgb);
    int green = cm.getGreen(rgb);
    int blue  = cm.getBlue(rgb);
    alpha = alpha == 0 ? 0 : this.alpha;
    return alpha << 24 | red << 16 | green << 8 | blue;
  }
}

/***************************************************************************/
/* CLASS:  CFilter  --  Color Mask Filter                                  */
/***************************************************************************/
class CFilter extends RGBImageFilter
{
	Color color;

  public CFilter(Color mask)
  {
		color = mask;
		canFilterIndexColorModel = true;
	}
	public int filterRGB(int x, int y, int pixel)
	{
    return 255 << 24 |
       (((pixel & 0xff0000) >> 16) * color.getRed()/255) << 16 |
       (((pixel & 0xff00) >> 8) * color.getGreen()/255) << 8 |
       (pixel & 0xff) * color.getBlue()/255 ;
	}
}


/***************************************************************************/
/* CLASS:  ShadowFilter  --  Shadow mask filter                            */
/***************************************************************************/
class ShadowFilter extends RGBImageFilter
{
  Color color;
  double edge;

  public ShadowFilter(int width, int height, Color mask)
  {
    edge = Math.sqrt(width*width + height*height); color = mask;
  }

  public int filterRGB(int x, int y, int pixel)
  {
    double fraction = 1.0 - Math.sqrt(x*x + y*y)/edge;
    if (fraction <= 0) return 0xFF000000;
    
    int red = (((pixel & 0xff0000) >> 16) * color.getRed()/255);
    
    int green = (((pixel & 0xff00) >> 8) * color.getGreen()/255);
    
    int blue = (pixel & 0xff) * color.getBlue()/255;

    int r = (int) (red * fraction);
    int g = (int) (green * fraction);
    int b = (int) (blue * fraction);

    return (0x000000FF << 24) | (r << 16) | (g << 8) | b;
  }
}


/***************************************************************************/
/* CLASS:  InvertFilter  --  Invert Colors                                 */
/***************************************************************************/
class InvertFilter extends RGBImageFilter
{
  public InvertFilter()
  { }
  public int filterRGB(int x, int y, int rgb) {
    int r = 0xff - (rgb >> 16) & 0xff;
    int g = 0xff - (rgb >> 8) & 0xff;
    int b = 0xff - rgb & 0xff;
    return (0xff000000 | r << 16 | g << 8 | b);
  }
}


/***************************************************************************/
/* CLASS:  GrayScale  --  GrayScale filter                                 */
/***************************************************************************/
class GrayScale extends RGBImageFilter
{
  public GrayScale()
  { }
  public int filterRGB(int x,int y,int rgb)
  {
    int r = (rgb >> 16) & 0xff;
    int g = (rgb >> 8) & 0xff;
    int b = rgb & 0xff;
    int k = (int) (.56 * g + .33 * r + .11 * b);
    return (0xff000000 | k << 16 | k << 8 | k);
  }
}

/***************************************************************************/
/* CLASS:  Contrast  --  Contrast filter                                   */
/***************************************************************************/
class Contrast extends RGBImageFilter
{
  double gain = 1.2;

  public Contrast()
  { }

  private int multclamp(int in, double factor)
  {
    in = (int) (in * factor);
    return in > 255 ? 255 : in;
  }

  private int cont(int in)
  {
    return (in < 128) ? (int)(in/gain) : multclamp(in, gain);
  }

  public int filterRGB(int x, int y, int rgb) {
    int r = cont((rgb >> 16) & 0xff);
    int g = cont((rgb >> 8) & 0xff);
    int b = cont(rgb & 0xff);
    return (0xff000000 | r << 16 | g << 8 | b);
  }
}


/***************************************************************************/
/* CLASS:  BleachFilter  --  Bleach filter                                 */
/***************************************************************************/
class BleachFilter extends RGBImageFilter {
  private double percent;

  public BleachFilter(int percent)
  {
    if(Math.abs(percent) < 0 || Math.abs(percent) > 100)
      throw new IllegalArgumentException("bad bleach percent");
    this.percent = (double)percent/100.0;
    canFilterIndexColorModel = true;
  }

  public int  getPercent()
  { return (int)percent*100; }

  public void setPercent(int percent)
  { this.percent = (double)percent/100.0; }

  public int filterRGB(int x, int y, int rgb)
  {
    DirectColorModel cm = (DirectColorModel)ColorModel.getRGBdefault();
    int    alpha = cm.getAlpha(rgb);
    int    red   = cm.getRed  (rgb);
    int    green = cm.getGreen(rgb);
    int    blue  = cm.getBlue (rgb);

    red = (int)(red + (red * percent));
    red = red <   0 ?   0 : red;
    red = red > 255 ? 255 : red;

    green = (int)(green + (green * percent));
    green = green <   0 ?   0 : green;
    green = green > 255 ? 255 : green;
    
    blue = (int)(blue + (blue * percent));
    blue = blue <   0 ?   0 : blue;
    blue = blue > 255 ? 255 : blue;

    return alpha << 24 | red << 16 | green << 8 | blue;
  }
}


/* CLASS:  WaveFilter  --  Wave filter **************************************/

class WaveFilter extends ImageFilter
{
  ColorModel defaultRGB = ColorModel.getRGBdefault();
  int amplitude, frequency, width, height;
  int sineArray[], intPixels[];

  public WaveFilter()
  {
    this(10,10);
  }

  public WaveFilter(int amplitude, int frequency)
  {
    this.amplitude = amplitude;
    this.frequency = frequency;
  }

  public void setDimensions(int width, int height)
  {
    int x;
    this.width  = width;
    this.height = height+(amplitude*2);
    intPixels   = new int[width * this.height];

    sineArray = new int[width];
    for(x=0; x < width; ++x)
    {
      sineArray[x] = ((int)(amplitude*Math.sin(((double)(x)) / ((double)frequency))));
    }
    consumer.setDimensions(width, this.height);
  }

  public void setProperties(Hashtable props) {
    String akey = "wave amplitude", fkey = "wave frequency";
    String aval = Integer.toString(amplitude), fval = Integer.toString(frequency);
    Object o = props.get(akey);
    if(o != null && o instanceof String)
      aval = ((String) o) + ", " + aval;
    o = props.get(fkey);
    if(o != null && o instanceof String)
      fval = ((String) o) + ", " + fval;
    props.put(akey, aval);
    props.put(fkey, fval);
    //System.out.println(props);
    consumer.setProperties(props); 
  }

  public void setColorModel(ColorModel model)
  {
    consumer.setColorModel(defaultRGB);
  }

  public void setHints(int hints)
  {
    hints |= TOPDOWNLEFTRIGHT | COMPLETESCANLINES;
    hints &= ~RANDOMPIXELORDER; 
    consumer.setHints(hints);
  }

  public void setPixels(int x, int y, int w, int h, ColorModel cm, int pixels[], int offset, int scansize)
  {
    int index, destY, destIndex = 0;
    for(int row=0; row < h; row++)
    {
      for(int col=0; col < w; col++)
      {
        destY = y + row + amplitude + sineArray[col];
        destIndex = (destY*w) + x + col;
        index = offset + row*scansize + col;
        intPixels[destIndex] = cm.getRGB(pixels[index]);
      }
    }
  }

  public void setPixels(int x, int y, int w, int h, ColorModel cm, byte pixels[], int offset, int scansize)
  {
    int index, destY, destIndex = 0;
    for(int row=0; row < h; row++)
    {
      for(int col=0; col < w; col++)
      {
        destY = y + row + amplitude + sineArray[col];
        destIndex = (destY*w) + x + col;
        index = offset + row*scansize + col;
        intPixels[destIndex] = cm.getRGB(pixels[index]);
      }
    }
  }

  public void imageComplete(int status)
  {
    if(status == IMAGEERROR || status == IMAGEABORTED)
    {
      consumer.imageComplete(status);
      return;
    }
    consumer.setPixels(0,0,width,height,defaultRGB,intPixels,0,width);
    consumer.imageComplete(status);
  }
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/